capture log close
log using drvisits, replace text
set more off
set scheme sj

use drvisit, clear

* inspect missing data patterns  
xtdes, i(id) t(reform)

* ordinary Poisson regression
poisson numvisit reform age educ married badh loginc summer, cluster(id) irr
estimates store ordinary 

glm numvisit reform age educ married badh loginc summer, ///
 family(poisson) link(log) cluster(id) eform

* overdispersion using random intercept at level 1
gen obs = _n
gllamm numvisit reform age educ married badh loginc summer, ///
 family(poisson) link(log) i(obs) eform adapt 
 
* overdispersion using quasilikelihood 
glm numvisit reform age educ married badh loginc summer, ///
 family(poisson) link(log) eform scale(x2)

* random intercept Poisson regression 
gen cons=1
eq ri: cons
gllamm numvisit reform age educ married badh loginc summer, ///
 family(poisson) link(log) i(id) eqs(ri) eform adapt 
estimates store randint

lrtest ordinary randint, force

gllamm, robust eform

* random coefficient Poisson regression 
matrix a=e(b)
eq rc: reform
gllamm numvisit reform age educ married badh loginc summer, ///
  family(poisson) link(log) i(id) nrf(2) eqs(ri rc) from(a) eform adapt 
estimates store randcoef

lrtest randint randcoef

gllamm, robust eform

* other approaches to clustered counts
xtpoisson numvisit reform age educ married badh loginc summer, fe irr i(id)

xtgee numvisit reform age educ married badh loginc summer, ///
  i(id) family(poisson) link(log) robust eform
  
log close
exit
